package sample03;

import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class StreamSample {

    public static void main(String[] args) {

        Stream<Hoge> stream = Stream.of(
                new Hoge(true, "aaa"),
                new Hoge(false, "bbb"),
                new Hoge(true, "ccc"));

        //StreamやOptionalには関数を受け取る高階メソッドが多くある
        List<Bar> bars = stream.filter(a -> a.isFoo())
                .map(a -> a.toBar())
                .flatMap(a -> Stream.of(a, a))
                .collect(Collectors.toList());

        System.out.println(bars); //[aaa, aaa, ccc, ccc]
    }

    static class Hoge {

        private boolean foo;
        private String bar;

        public Hoge(boolean foo, String bar) {
            this.foo = foo;
            this.bar = bar;
        }

        public boolean isFoo() {
            return foo;
        }

        public Bar toBar() {
            return new Bar(bar);
        }
    }

    static class Bar {

        private String value;

        public Bar(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return value;
        }
    }
}
