package sample04;

import java.math.BigDecimal;
import java.util.Optional;

public class MultiOptionalSample {

    public static void main(String[] args) {

        //Optionalを使う場合

        Optional<BigDecimal> oa = Optional.of(new BigDecimal("12"));
        Optional<BigDecimal> ob = Optional.of(new BigDecimal("34"));
        Optional<BigDecimal> oz = Optional.empty();

        System.out.println(add(oa, ob)); //46
        System.out.println(add(oa, oz)); //0
        System.out.println(add(oz, ob)); //0
        System.out.println(add(oz, oz)); //0

        //Optionalを使わない場合

        BigDecimal a = new BigDecimal("12");
        BigDecimal b = new BigDecimal("34");
        BigDecimal z = null;

        System.out.println(add(a, b)); //46
        System.out.println(add(a, z)); //0
        System.out.println(add(z, b)); //0
        System.out.println(add(z, z)); //0
    }

    static BigDecimal add(Optional<BigDecimal> oa,
            Optional<BigDecimal> ob) {
        Optional<BigDecimal> oc = oa.flatMap(a -> ob.map(b -> a.add(b)));
        return oc.orElse(BigDecimal.ZERO);
    }

    static BigDecimal add(BigDecimal a, BigDecimal b) {
        if (a != null && b != null) {
            return a.add(b);
        }
        return BigDecimal.ZERO;
    }
}
