package sample05;

import java.util.stream.Stream;

public class LambdaAndExceptionSample {

    public void run() {

        Stream<Hoge> stream = Stream.empty();

        //チェック例外を投げない場合
        stream.map(a -> a.toFoo());
        stream.map(Hoge::toFoo); //メソッド参照も利用できる

        //チェック例外を投げる場合
        stream.map(a -> {
            try {
                return a.toBar();
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        });

    }

    interface Hoge {
        String toFoo();
        String toBar() throws Exception;
    }
}
