package sample06;

import java.util.ArrayList;
import java.util.List;
import java.util.function.BiConsumer;
import java.util.function.BinaryOperator;
import java.util.function.Supplier;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class CollectorSample {

    public static void main(String[] args) {
        List<Integer> list = IntStream.rangeClosed(1, 10).boxed().collect(Collectors.toList());

        List<Pair> pairs = list.stream().collect(toPair());

        System.out.println(pairs); //[(1, 2), (3, 4), (5, 6), (7, 8), (9, 10)]
    }

    static Collector<Integer, ?, List<Pair>> toPair() {
        Supplier<List<Pair>> supplier = ArrayList::new;
        BiConsumer<List<Pair>, Integer> accumulator = (list, element) -> {
            if (list.isEmpty()) {
                //先頭の要素を処理する
                Pair pair = new Pair();
                pair.first = element;
                list.add(pair);
            } else {
                //secondがなければ組を作り、
                //あれば新しいPairインスタンスを生成する
                Pair pair = list.get(list.size() - 1);
                if (pair.second == null) {
                    pair.second = element;
                } else {
                    pair = new Pair();
                    pair.first = element;
                    list.add(pair);
                }
            }
        };
        BinaryOperator<List<Pair>> combiner = (l1, l2) -> {
            l1.addAll(l2);
            return l1;
        };
        return Collector.of(supplier, accumulator, combiner);
    }
}
