package sample06;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class IteratorSample {

    public static void main(String[] args) {
        List<Integer> list = IntStream.rangeClosed(1, 10).boxed().collect(Collectors.toList());

        List<Pair> pairs = new ArrayList<>();
        for (Iterator<Integer> it = list.iterator(); it.hasNext();) {
            Pair pair = new Pair();
            pair.first = it.next();
            pair.second = it.hasNext() ? it.next() : null;
            pairs.add(pair);
        }
        System.out.println(pairs); //[(1, 2), (3, 4), (5, 6), (7, 8), (9, 10)]
    }
}
