package sample08;

import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import sample08.model.Bar;
import sample08.model.Baz;
import sample08.model.Foo;
import sample08.model.Hoge;

public class ComposeSample1 {

    public static void main(String[] args) {

        int n = 3;
        Stream<Hoge> stream = Stream.of(new Hoge("aaa"), new Hoge("bbb"), new Hoge("ccc"));

        //mapの引数をそれぞれ変数に切り出す
        Function<Hoge, Foo> toFoo = a -> Foo.fromHoge(a);
        Function<Foo, Bar> toBar = toBar(n);
        Function<Bar, Baz> toBaz = Bar::getBaz;

        //andThenで合成する
        Function<Hoge, Baz> hogeToBaz = toFoo.andThen(toBar).andThen(toBaz);

        //mapの呼び出しが1つになる
        List<Baz> ret = stream.map(hogeToBaz)
                .collect(Collectors.toList());

        System.out.println(ret); //[3:aaa, 3:bbb, 3:ccc]

        //新しい組み合わせで別の処理にも再利用できる
        Function<Hoge, Bar> hogeToBar = toFoo.andThen(toBar);
        Stream<Hoge> stream2 = Stream.of(new Hoge("aaa"), new Hoge("bbb"), new Hoge("ccc"));
        stream2.map(hogeToBar);
    }

    static Function<Foo, Bar> toBar(int n) {
        return f -> new Bar(n, f);
    }
}
